#include <amxmodx>
#include <amxmisc>
#include <codmod>
#include <engine>
#include <hamsandwich>
#include <fakemeta>
#include <colorchat>
#include <cstrike>
        
new const nazwa[]   = "Szpieg";
new const opis[]    = "Posiada podwojny skok w powietrzu, 2 miny i ubranie wroga";
new const bronie    = (1<<CSW_MP5NAVY)|(1<<CSW_DEAGLE)|(1<<CSW_AK47);
new const zdrowie   = 25;
new const kondycja  = 20;
new const inteligencja = 5;
new const wytrzymalosc = 15;
    
new const modelMiny[] = "models/QTM_CodMod/mine.mdl"

new sprite_blast_miny;
new ilosc_min_gracza[33];

new skoki[33];

new bool:ma_klase[33];

public plugin_init()
{
	register_plugin(nazwa, "1.0", "Enson");

	cod_register_class(nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);
	register_touch("mine", "player",  "DotykMiny");

	register_event("HLTV", "NowaRunda_Miny", "a", "1=0", "2=0");

	RegisterHam(Ham_Spawn, "player", "fwSpawn_Miny", 1);

   
	register_forward(FM_CmdStart, "fwCmdStart_MultiJump");

}

public plugin_precache()
{

	precache_model(modelMiny);
	sprite_blast_miny = precache_model("sprites/dexplo.spr");

}

public client_disconnect(id)
{

	new entMiny = find_ent_by_class(0, "mine");
	while(entMiny > 0)
	{
		if(entity_get_edict(entMiny, EV_ENT_owner) == id)
			remove_entity(entMiny);
		entMiny = find_ent_by_class(entMiny, "mine");
	}

}

public cod_class_enabled(id)
{
	if(!(get_user_flags(id) & ADMIN_LEVEL_C))
	{
		ColorChat(id, GREY, "[%s] Nie masz uprawnien, aby uzywac tej klasy.", nazwa);
		return COD_STOP;
	}
	
	ilosc_min_gracza[id] = 2;
	ma_klase[id] = true;
	ZmienUbranie(id, 0) // wcza przebranie
   
	return COD_CONTINUE;
}

public cod_class_disabled(id)
{
	ma_klase[id] = false;
	ZmienUbranie(id, 1) // wycza przebranie
}

public cod_class_skill_used(id)
{
        
	if (!ilosc_min_gracza[id])
	{
		client_print(id, print_center, "Wykorzystales juz wszystkie miny!");
	}
	else
	{

		ilosc_min_gracza[id]--;

		new Float:origin[3];
		entity_get_vector(id, EV_VEC_origin, origin);

		new ent = create_entity("info_target");
		entity_set_string(ent ,EV_SZ_classname, "mine");
		entity_set_edict(ent ,EV_ENT_owner, id);
		entity_set_int(ent, EV_INT_movetype, MOVETYPE_TOSS);
		entity_set_origin(ent, origin);
		entity_set_int(ent, EV_INT_solid, SOLID_BBOX);

		entity_set_model(ent, modelMiny);
		entity_set_size(ent,Float:{-16.0,-16.0,0.0},Float:{16.0,16.0,2.0});

		drop_to_floor(ent);

		set_rendering(ent,kRenderFxNone, 0,0,0, kRenderTransTexture,50);
	}
}

public fwSpawn_Miny(id)
{
	if(is_user_alive(id))
		ilosc_min_gracza[id] = 2;
}

public DotykMiny(ent, id)
{
	if(!is_valid_ent(ent))
		return;

	new attacker = entity_get_edict(ent, EV_ENT_owner);
	if (get_user_team(attacker) != get_user_team(id))
	{
		new Float:fOrigin[3];
		entity_get_vector( ent, EV_VEC_origin, fOrigin);

		new iOrigin[3];
		for(new i=0;i<3;i++)
			iOrigin[i] = floatround(fOrigin[i]);

		message_begin(MSG_BROADCAST,SVC_TEMPENTITY, iOrigin);
		write_byte(TE_EXPLOSION);
		write_coord(iOrigin[0]);
		write_coord(iOrigin[1]);
		write_coord(iOrigin[2]);
		write_short(sprite_blast_miny);
		write_byte(32);
		write_byte(20);
		write_byte(0);
		message_end();

		new entlist[33];
		new numfound = find_sphere_class(ent,"player", 90.0 ,entlist, 32);

		for (new i=0; i < numfound; i++)
		{
			new pid = entlist[i];

			if (!is_user_alive(pid) || get_user_team(attacker) == get_user_team(pid))
				continue;

			cod_inflict_damage(attacker, pid, 70.0, 0.8, ent, (1<<24));
		}
		remove_entity(ent);
	}
}

public NowaRunda_Miny()
{
	new entMiny = find_ent_by_class(-1, "mine");
	while(entMiny > 0)
	{
		remove_entity(entMiny);
		entMiny = find_ent_by_class(entMiny, "mine");
	}
}

public fwCmdStart_MultiJump(id, uc_handle)
{
	if(!is_user_alive(id) || !ma_klase[id])
		return FMRES_IGNORED;

	new flags = pev(id, pev_flags);

	if((get_uc(uc_handle, UC_Buttons) & IN_JUMP) && !(flags & FL_ONGROUND) && !(pev(id, pev_oldbuttons) & IN_JUMP) && skoki[id])
	{
		skoki[id]--;
		new Float:velocity[3];
		pev(id, pev_velocity,velocity);
		velocity[2] = random_float(265.0,285.0);
		set_pev(id, pev_velocity,velocity);
	}
	else if(flags & FL_ONGROUND)
		skoki[id] = 1;

	return FMRES_IGNORED;
}

public ZmienUbranie(id,reset)
{
        if (id<1 || id>32 || !is_user_connected(id)) 
                return PLUGIN_CONTINUE;
        
        if (reset)
                cs_reset_user_model(id);
        else
        {
                new Ubrania_CT[4][] = {"sas","gsg9","urban","gign"},
                Ubrania_Terro[4][] = {"arctic","leet","guerilla","terror"};
                
                new num = random_num(0,3);
                switch(get_user_team(id))
                {
                        case 1: cs_set_user_model(id, Ubrania_CT[num]);
                        case 2:cs_set_user_model(id, Ubrania_Terro[num]);
                }
        }
        
        return PLUGIN_CONTINUE;
}
