#include <amxmodx>
#include <amxmisc>
#include <codmod>
#include <engine>
#include <hamsandwich>
#include <cstrike>
#include <colorchat>
#include <fun>
        
new const nazwa[]   = "Ninja";
new const opis[]    = "Posiada 1/1 z kosy (PPM), mniejsza grawitacje i jest slabo widoczny";
new const bronie    = (1<<CSW_C4);
new const zdrowie   = 30;
new const kondycja  = 30;
new const inteligencja = 0;
new const wytrzymalosc = 0;
    
new bool:ma_klase[33];

#define DMG_BULLET (1<<1)

public plugin_init()
{
	register_plugin(nazwa, "1.0", "Enson");

	cod_register_class(nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);   
	RegisterHam(Ham_Spawn, "player", "fwSpawn_Grawitacja", 1);
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage");
	register_event("CurWeapon","CurWeapon","be", "1=1");

}

public cod_class_enabled(id)
{
	if(!(get_user_flags(id) & ADMIN_LEVEL_D))
	{
		ColorChat(id, GREY, "[%s] Nie masz uprawnien, aby uzywac tej klasy.", nazwa);
		return COD_STOP;
	}

	set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, 9);

 	entity_set_float(id, EV_FL_gravity, 550.0/800.0);
	cs_set_user_defuse(id, 1);
	ma_klase[id] = true;
	
   
	return COD_CONTINUE;
}

public cod_class_disabled(id)
{
	set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, 255);
    
 	entity_set_float(id, EV_FL_gravity, 1.0);
	ma_klase[id] = false;
}

public fwSpawn_Grawitacja(id)
{
	if(ma_klase[id])
		entity_set_float(id, EV_FL_gravity, 550.0/800.0);
}

public TakeDamage(this, idinflictor, idattacker, Float:damage, damagebits)
{
        if(!is_user_connected(idattacker))
                return HAM_IGNORED;
        
        if(!ma_klase[idattacker])
                return HAM_IGNORED;
                
        if(get_user_weapon(idattacker) == CSW_KNIFE && damagebits & DMG_BULLET && !(get_user_button(idattacker) & IN_ATTACK))
                cod_inflict_damage(idattacker, this, float(get_user_health(this))-damage+1.0, 0.0, idinflictor, damagebits);
                
        return HAM_IGNORED;
}

public CurWeapon(id)
{
        if(ma_klase[id] && read_data(2) != CSW_KNIFE)
        {
                        set_task(0.1 ,"ma" ,id)
        }
}

public ma(id)
{
        strip_user_weapons(id);
        give_item(id, "weapon_knife");
}
